/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _NEWTMENU_H_
#define _NEWTMENU_H_

#include <string>

#include "../newtEngine/entity.h"




class NewtMenu: public EntityWithPosition 
{
public:
	NewtMenu(wstring title, Vector3 center, Vector3 rotAxis, float angle);
	~NewtMenu();
		
	void setMenuItems(std::vector<wstring> menuNames, int numTextColor, float numTextColorCoeff, int numBackgroundColor, float backgroundColorCoeff, float width, float height);
		
	int getSelectedMenuItem();
	void selectMenuItem(int numMenuItem);
		
		
protected:
	wstring mTitle;
	int mSelectedMenuItem;

};


class NewtMenuItem: public Entity
{
public:
	NewtMenuItem(wstring name, int numTextColor, float numTextColorCoeff, int numBackgroundColor, float backgroundColorCoeff, float width, float height, int position);
	~NewtMenuItem();
	
	void applyTransformation();
		
		
protected:
	wstring mName;
	Vector3 mPosition;
};








#endif // _NEWTMENU_H_
