/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "screenshot.h"


std::string findFilePath(std::string name) {
	std::string filepath;
	int i=1;
	bool test = true;
	
	while(test) {
		ostringstream oss;
		oss << fileMana->getScreenshotsDir() << "/" << name << i << ".png";
		i++;
		filepath = oss.str();
		test = fileExists(filepath);
	}
	
	return filepath;	
}


void screenshot(std::string name) {
	std::string fileName = findFilePath (name);

	int width = generalGraphics->getScreenWidth();
	int height = generalGraphics->getScreenHeight();
	GLubyte* texels = new GLubyte[width*height*3];
	
	//glPixelStorei(GL_PACK_ALIGNMENT, 1);
	glReadPixels(0, 0, width, height, GL_RGB, GL_UNSIGNED_BYTE, texels);	
	
	ImagePng *image = new ImagePng (width, height, GL_RGB, texels);
	
	image->writeToFile(fileName);
	
	delete image;
}

